Imports System.Text.RegularExpressions

Public Class ChemInfo
    Public Name As String
    Public Formula As String
    Public Picture As Image

    Public Sub New(ByVal new_name As String, ByVal new_formula As String, ByVal new_picture As Image)
        Name = new_name
        Formula = new_formula
        Picture = new_picture
    End Sub

    ' Draw the ChemInfo's formula and name at the indicated Y coordinate.
    Public Sub DrawChemInfo(ByVal gr As Graphics, ByVal br As Brush, ByVal fnt As Font, ByVal y As Integer, ByVal hgt As Integer)
        ' Find the top lines for the strings.
        Dim y0 As Integer = y + hgt \ 7
        Dim y1 As Integer = y0 + hgt \ 4

        ' Draw the name.
        gr.DrawString(Me.Name & " (", fnt, br, 0, y0)

        Dim text_size As SizeF = gr.MeasureString(Me.Name & " (", fnt)
        Dim x As Integer = text_size.Width

        ' Draw the formula.
        ' See how much extra space is added after strings.
        Dim size1 As SizeF = gr.MeasureString("X", fnt)
        Dim size2 As SizeF = gr.MeasureString("XX", fnt)
        Dim kern As Integer = 2 * size1.Width - size2.Width
        x -= kern

        ' Find runs of non-digits and runs of digits.
        Dim reg_exp As New Regex("(\D*)(\d*)")
        Dim a_match As Match = reg_exp.Match(Me.Formula)
        While a_match.Success
            ' Draw this match's groups.
            For g As Integer = 1 To a_match.Groups.Count - 1
                Dim grp_text As String = a_match.Groups(g).Value
                If grp_text.Length > 0 Then
                    If grp_text.Substring(0, 1) >= "0" AndAlso grp_text.Substring(0, 1) <= "9" Then
                        gr.DrawString(grp_text, fnt, br, x, y1)
                    Else
                        gr.DrawString(grp_text, fnt, br, x, y0)
                    End If
                    Dim ch_size As SizeF = gr.MeasureString(grp_text, fnt)
                    x += ch_size.Width - kern
                End If
            Next g

            a_match = a_match.NextMatch()
        End While

        gr.DrawString(")", fnt, br, x, y0)
    End Sub

End Class
