Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstFormulas.DrawMode = DrawMode.OwnerDrawVariable

        lstFormulas.Items.Add(New ChemInfo("Sulfuric Acid", "H2SO4", My.Resources.H2SO4))
        lstFormulas.Items.Add(New ChemInfo("Water", "H2O", My.Resources.H2O))
        lstFormulas.Items.Add(New ChemInfo("Hydrochloric Acid", "HCl", My.Resources.HCL))
        lstFormulas.Items.Add(New ChemInfo("Acetone", "CH3COCH3", My.Resources.CH3COCH3))
        lstFormulas.Items.Add(New ChemInfo("Ethenol", "C2H4O", My.Resources.C2H4O))
        lstFormulas.Items.Add(New ChemInfo("Propanol", "C3H8O", My.Resources.C3H8O))
        lstFormulas.Items.Add(New ChemInfo("Capsaicin", "C18H27NO3", My.Resources.C18H27NO3))
    End Sub

    ' Draw an item.
    Private Sub lstFormulas_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles lstFormulas.DrawItem
        ' Draw the background.
        e.DrawBackground()

        ' Draw the text.
        Dim lst As ListBox = DirectCast(sender, ListBox)
        Dim ci As ChemInfo = DirectCast(lst.Items(e.Index), ChemInfo)

        Dim br As Brush = Nothing
        If e.State And DrawItemState.Selected Then
            br = SystemBrushes.HighlightText
        Else
            br = New SolidBrush(e.ForeColor)
        End If

        ci.DrawChemInfo(e.Graphics, br, lst.Font, e.Bounds.Top, e.Bounds.Height)

        ' Draw the focus rectangle if appropriate.
        e.DrawFocusRectangle()
    End Sub

    ' Calculate the size of an item.
    Private Sub lstFormulas_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs) Handles lstFormulas.MeasureItem
        Dim lst As ListBox = DirectCast(sender, ListBox)
        Dim ci As ChemInfo = DirectCast(lst.Items(e.Index), ChemInfo)
        Dim item_size As SizeF = _
            e.Graphics.MeasureString( _
                ci.Name & " (" & ci.Formula & ")", lst.Font)
        e.ItemHeight = 2 * item_size.Height
        e.ItemWidth = item_size.Width
    End Sub

    ' Display the selected item's image.
    Private Sub lstFormulas_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFormulas.SelectedIndexChanged
        Dim chem_info As ChemInfo = DirectCast(lstFormulas.SelectedItem, ChemInfo)
        picImage.Image = chem_info.Picture
    End Sub
End Class
